#include <windows.h>
#include <stdio.h>
#include <afxres.h>
#include <tchar.h>
#include "resource.h"

#define WM_UPDATECONTLABEL    WM_APP + 100
#define WM_CHANGECONTLABEL    WM_APP + 101

#define COUNTOF(x)  (sizeof(x)/sizeof(x[0]))

HINSTANCE g_hInst = NULL;
HWND hwndCtrlDlg = NULL, hwndContDlg = NULL;

BOOL CALLBACK CtrlDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		switch (wp)
		{
		case IDC_BUTTON1:
			{
				TCHAR txt[4096] = {0};
				HWND hwndEdit = GetDlgItem(hDlg, IDC_EDIT1);
				GetWindowText(hwndEdit, txt, COUNTOF(txt));
				SendMessage(GetParent(hDlg), WM_CHANGECONTLABEL, _tcslen(txt), (LPARAM)txt);
			}
			break;
		}
		break;

	case WM_CLOSE:
		//MessageBox(hDlg, TEXT("Child dialog must not be closed"), TEXT("Error"), MB_OK | MB_ICONHAND);
		SendMessage(GetParent(hDlg), msg, wp, lp);
		break;
	}

	return FALSE;
}

BOOL CALLBACK ContDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_UPDATECONTLABEL:
		{
			HWND hwndLabel = GetDlgItem(hDlg, IDC_LABEL);
			SetWindowText(hwndLabel, (LPCTSTR)lp);
		}
		break;

	case WM_CLOSE:
		//MessageBox(hDlg, TEXT("Child dialog must not be closed"), TEXT("Error"), MB_OK | MB_ICONHAND);
		SendMessage(GetParent(hDlg), msg, wp, lp);
		break;
	}

	return FALSE;
}

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		{
			RECT rc = {0};

			// create CONTROL child
			hwndCtrlDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_CTRL), hDlg, (DLGPROC)CtrlDlgProc);
			GetClientRect(hwndCtrlDlg, &rc);
			OffsetRect(&rc, 10, 10);
			MoveWindow(hwndCtrlDlg, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, FALSE);
			ShowWindow(hwndCtrlDlg, SW_SHOWNORMAL);
			UpdateWindow(hwndCtrlDlg);
	
			// create CONTAINER child
			GetClientRect(hDlg, &rc);
			int offset = rc.right / 2;

			hwndContDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_CONT), hDlg, (DLGPROC)ContDlgProc);
			GetWindowRect(hwndContDlg, &rc);
			MapWindowPoints(GetDesktopWindow(), hDlg, (LPPOINT)&rc, 2);
			OffsetRect(&rc, offset + 10, 10);
			MoveWindow(hwndContDlg, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, FALSE);
			ShowWindow(hwndContDlg, SW_SHOWNORMAL);
			UpdateWindow(hwndContDlg);
		}
		return TRUE;

	case WM_CHANGECONTLABEL:
		{
			// make sure CONTROL exists
		    if (!IsWindow(hwndContDlg))
		    	break;

		    // route label text to CONTAINER
			SendMessage(hwndContDlg, WM_UPDATECONTLABEL, 0, lp);
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hwndCtrlDlg);
		DestroyWindow(hwndContDlg);
		EndDialog(hDlg, 0);
		break;
	}

	return FALSE;
}

int WINAPI _tWinMain(HINSTANCE hInst, HINSTANCE hPrev, LPTSTR szCmd, INT nShow)
{
    g_hInst = hInst;
	DialogBox(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)MainDlgProc);
	return 0;
}
